// sirt.C 11/02  Htet Khant
//N make3dsirt 
//F Misc. 3d image processing
//T LM
//1
//P in=<input file>	Initial 3-D model (MRC file)
//P iter=<iterMax>	# of iteration
//P prop=<ang>	Angular increment for projection generation 
//U make3dsirt in=start3D.mrc iter=50 prop=100
//D This program performs Simultaneous Iterative Reconstruction Technique. 
//E THE PROGRAM IS STILL UNDER TESTING AND DEVELOPMENT!!! 
//E User supplies intitial 3-D model (MRC file)
//E 
//D 
//E 
//E 
//E <UL>
//E <LI> To use SIRT, number of iteration (iter).
//E </UL>

#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"
#include "Euler.h"
#include <ctype.h>

main(int argc, char *argv[]) {

  EMData *d,*f,*p,*p2,*q,*q2;
  float alt,az,phi,r,h,az0=0,az1=2.0*PI,alt1=PI/2.0,alt0=0;
  float *dat,arng[6];
  float Constant = 3.6,prop=0,hsym=0,phitoo=0;
  int i,j,k,mask=-1,iter,iterMax=1; 
  int mode=-1,phic=0,csym=1;
  FILE *outf;
  char *in=NULL,s[80],*l,*out="proj.hed",*out2="proj.img",projout[80],projout2[80];

  int nx,ny,nz;
  EMData *d0,*new3d,*dout,*dnewd,*dnewdsize,*dnewdsave;
  List *dnew,*dnewsave;
  char new3dout[80];

  //read input parameters
  appinit(argc,argv);
  if (argc<2) appusage(argv[0]);

  for (i=1; i<argc; i++) {	
    if (strncmp(argv[i],"in=",3)==0) in=argv[i]+3;
    else if (strncmp(argv[i],"out=",4)==0) {
      out=&argv[i][4];
      if (strcmp(&out[strlen(out)-4],".hed")==0) {
	out2=(char *)malloc(strlen(out)+1);
	strcpy(out2,out);
	sprintf(&out2[strlen(out2)-4],".img");
      } else {
	out2=(char *)malloc(strlen(out)+1);
	strcpy(out2,out);
	sprintf(&out2[strlen(out2)-4],".hed");
      }
		
    }
    else if (strncmp(argv[i],"iter=",5)==0) iterMax=atoi(&argv[i][5]);
    else if (strncmp(argv[i],"prop=",5)==0) prop=atoi(&argv[i][5]);
    else { printf("Unknown option %s\n",argv[i]); exit(1); }
  }


  ///////////////////
  // read 3D image //
  ///////////////////

  d=new EMData;
  if (d->readImage(in,-1)) error("Cannot read input",ERR_EXIT);


  //Begin Main Loop for SIRT Iteration
  for (iter=1;iter<iterMax+1;iter++) {


    ////////////////////////////////////////
    // generate projections from 3D image //
    ////////////////////////////////////////

    phitoo=prop;
    phi=az=0;

    //apply symmetry if known
    if (csym==60) csym=-5;
    if (csym==24) csym=-4;

    //main projection generation loop
    for (i=1,j=0,alt=alt0; alt<=alt1+prop*PI/360.0; alt+=prop*PI/180.0,j++) {
      h=floor(360.0/(prop*1.1547));	// the 1.1547 makes the overall distribution more like a hexagonal mesh
      h=(int)floor(h*sin(alt)+.5);
      if (h==0) h=1;
      h=abs(csym)*floor(h/(float)abs(csym)+.5);
      h=2.0*PI/h;
      if (alt>0 && (az1-az0)/h<2.8) h=(az1-az0)/2.1;
      if (alt==0) h=az1;		
      for (az=az0+(j%1)?h/2.0:0; az<az1-h/4; az+=h) {
	for (phi=0; phi<(phitoo?(PI*2.0-phitoo*PI/360.0):0.0001); phi+=(phitoo?phitoo:180.0)*PI/180.0,i++) {
	  if (csym==-4 && tan(alt)*cos((az>PI/4.0)?(PI/2.0-az):az)>1.0) { i--; continue; }
	  if (phic) phi=-az*cos(alt);
	  else q=d->project3d(alt,az,phi,mode);
	  q->applyMask(-1,100+mode);
	  q->applyMask(mask,6);
	  q->setRAlign(alt,az,phi);
	  q->setNImg(1);
	  sprintf(projout,"proj.%d",iter);
	  q->writeIMAGIC(projout,i-1);
	  if (phic) phi=0;
	}
      }
      delete q;
    }
    //sprintf(s,"prop %1.2f",prop);


    /////////////////////////////////////////////////////////
    //compare projections at current and previous iteration//
    //        and update the current projection            //
    /////////////////////////////////////////////////////////

    //read projections
    strcpy(projout2,projout);
    strcat(projout2,".hed");

    //set size for 3D model
    dnew=readImages(projout2,0,-1);
    for (i=0; i<dnew->count(); i++) {
      dnewdsize=(EMData *)dnew->objectAt(i);
      new3d=new EMData;
      new3d->setSize(dnewdsize->xSize(),dnewdsize->xSize(),dnewdsize->xSize());
      new3d->zero();
    }
    delete dnewdsize;
    
    if (dnew->count()<3) {printf("Need at least 3 images!\n");exit(1);}
    if (iter==1) {
      dnew=readImages(projout2,0,-1);
      for (i=0; i<dnew->count(); i++) {
	dnewd=(EMData *)dnew->objectAt(i);
	dnewd->multConst(0.5);
	new3d->insertSlice3DReal(dnewd,dnewd->NImg());//generate 3d Model by backprojection
      }
      delete dnew;
    }
    else if (iter>1){
      dnewsave=readImages(projout2,0,-1);
      for (i=0; i<dnew->count(); i++) {
	dnewd=(EMData *)dnew->objectAt(i);
	dnewdsave=(EMData *)dnewsave->objectAt(i);
	dnewd->subtract(dnewdsave);
	dnewd->multConst(0.5);
	dnewd->add(dnewdsave);
	new3d->insertSlice3DReal(dnewd,dnewd->NImg());//generate 3d Model by backprojection
      }
      delete dnewsave;
      delete dnewdsave;
    }


    sprintf(new3dout,"3dnew.%d",iter);
    strcat(new3dout,".mrc");
    new3d->writeMRC(new3dout);

    // Apply symmetry if it was specified
    //if (sym) {
    //Euler e,*a;
    //EMData *d,*d2;
    //int ns=0;

    //d=out->copy();
    //d->setParent(NULL);
    //d2=d->copy();

    //printf("Applying %s symmetry\n",sym);
    //a=d->getEuler();
    //a->setAngle(0,0,0);
    //a->setSym(sym);
    //out->zero();
    //for (e=a->FirstSym(); e.valid(); e=a->NextSym(),ns++) {
    //printf("Angle %f,%f,%f\n",e.alt()*180/PI,e.az()*180/PI,e.phi()*180/PI);
    //d2->setRAlign(e.alt(),e.az(),e.phi());
    //d2->rotateAndTranslate();
    //out->add(d2);
    //}
    //new3d->multConst(1.0/ns);
    //delete d;
    //delete d2;
    //}

    printf("SIRT completed %d iterations\n",iter);

  }//End Main Loop for SIRT Iteration
  delete new3d; 
}//End Program Loop
