#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <qapp.h>
#include <qinputdialog.h>
#include <qcstring.h>
#include "Image.h"
#include "ImageMx.h"
#include "EMData.h"
#include "List.h"
#include "util.h"

#define  FILE_SIZE 50000000
int main( int argc, char **argv )
{  
    QApplication a( argc, argv );
    Image *im;
    ImageMx *imM;
    EMData *dat;
    int i, j, k, res;
    List*  EMDataList;
    struct stat f_info;
    int nCount;
    //int *type;
    appinit(argc,argv);
    if( argc <2)
    {
	cout << "Usage: v2 [imge1] ...."<<endl;
	cout << "To display one or multiple images" << endl;
	exit(1);
    }
   

//Equation::init();
    for(i=1; i<argc; i++)
    {
	dat=new EMData;
	j = fileCount(argv[i]);
	
	if(j ==1)
	{
	    dat->readImage(argv[i],-1);
	    im=new Image;
	    im->setData(dat);
	    im->show();
	}
	else if( j >1 )
	{
	    res = -1;
	    imM = new ImageMx;
	    imM->setAutoDelete(1);
	    if(!stat(argv[i], &f_info))
	    {
		if(f_info.st_size > FILE_SIZE)
		{
		    QCString cstr;
		    
		    res = QInputDialog::getInteger( 
			    QObject::tr( "Note: Demo Images Select Dialog."),
			    cstr.sprintf("Total Images in file are : %d.\n"
					 "How many Images do you want to display?", j) );
		}
	    
		EMDataList = readImages(argv[i], 0, -1);
		nCount = EMDataList->count();
		if(res != -1)
		{
		    if(nCount >=res)  nCount = res;
		}
		for( k = 0; k<nCount; k++)
		{
		    imM->addData( (EMData*)(EMDataList->objectAt(k)), -1);
		}
		imM->show();
	    }
	}
	
    }
    QObject::connect(qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()));
    return a.exec();
}
